// GetMacAddrDlg.cpp : t@C
//

#include "stdafx.h"
#include "WinWol.h"
#include "GetMacAddrDlg.h"
#include "afxdialogex.h"
#include "GlobalFunc.h"

// CGetMacAddrDlg _CAO

IMPLEMENT_DYNAMIC(CGetMacAddrDlg, CDialog)

CGetMacAddrDlg::CGetMacAddrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetMacAddrDlg::IDD, pParent)
	, m_Host(_T(""))
	, m_MacAddr(_T(""))
{
	m_TimeOut = ICMP_ECHO_TIME_OUT;
	m_Type = 0;
}

CGetMacAddrDlg::~CGetMacAddrDlg()
{
}

BOOL	CGetMacAddrDlg::SrchMacAddr(LPCTSTR szHost)
{
	struct hostent	*hp;
	CString			sIpAddr;
	CString			msg;
	BOOL			ret = TRUE;	

	if (!szHost || !(*szHost)) {
		msg.LoadString(IDS_STRING_SET_HOST_OR_IPADDR);
		MessageBox(msg);
		return FALSE;
	}

	hp = gethostbyname((LPCTSTR)szHost);
	if (hp) {
		sIpAddr = inet_ntoa(*((struct in_addr *)hp->h_addr));
		if (sIpAddr.IsEmpty()) {
			msg.LoadString(IDS_STRING_IP_ADDRESS_NOT_FOUND);
			MessageBox(msg);
			return FALSE;
		}
	} else {
		sIpAddr = szHost;
	}
	char	macaddr_str[32];

	if (!IpAddrToMacAddr((LPCTSTR)sIpAddr, macaddr_str, sizeof(macaddr_str))) {
		msg.LoadString(IDS_STRING_MAC_ADDR_NOT_FOUND);
		MessageBox(msg);
		return FALSE;
	}
	SetMacAddr(macaddr_str);

	return ret;
}

void CGetMacAddrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_HOST_NAME, m_Host);
	DDX_Text(pDX, IDC_EDIT_MAC_ADDR, m_MacAddr);
}


BEGIN_MESSAGE_MAP(CGetMacAddrDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_ARP, &CGetMacAddrDlg::OnBnClickedButtonArp)
END_MESSAGE_MAP()


// CGetMacAddrDlg bZ[W nh[


BOOL CGetMacAddrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ɏǉĂ
	UpdateData(FALSE);

	CWnd	*pWnd = GetDlgItem(IDOK);
	if (pWnd) {
		if (m_Type) {
			pWnd->ShowWindow(SW_SHOW);
		} else {
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDCANCEL);
			if (pWnd) {
				CString	str;
				str.LoadString(IDS_STRING_CLOSE);
				pWnd->SetWindowText(str);
			}
		}
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CGetMacAddrDlg::OnOK()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	UpdateData(TRUE);

	if (!SrchMacAddr((LPCTSTR)m_Host)) {
		return;
	}
	CDialog::OnOK();
}


void CGetMacAddrDlg::OnCancel()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB

	CDialog::OnCancel();
}


void CGetMacAddrDlg::OnBnClickedButtonArp()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	UpdateData(TRUE);

	SrchMacAddr((LPCTSTR)m_Host);

	UpdateData(FALSE);
}
